/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_IO_TAG_H
#define _PICONF_IO_TAG_H

#include "../piconfm.hpp"
#include "../../../pugixml/pugixml.hpp"
#include "../../../vio/IO.hpp"
#include <deque>
#include <string>
#include <utility>
#include <inttypes.h>

class piconf::io_tag : public tag {
protected:
	VIO::IO* io;
	std::deque<data_tag*> data_box;
	size_t io_state;
	static const uint8_t
	INSTRUCT = 0x01;
	class Progress {
	public:
		size_t done;
		size_t size;
		size_t fail;
		std::string what;
		Progress();
	};
	struct progress_t {
		Progress pkg;
		Progress tag;
		Progress all;
	} i_progress, o_progress;
	size_t data;
	io_tag(pugi::xml_node node);
	bool instruct(bool fail = false, bool exit = false);
public:
	void subscribe(std::deque<io_tag*>& io_box, bool inherit);
	void subscribe(data_tag* data);
	void status(lines_t& lines);
	void setup();
	virtual bool process();
	void push(const void* query, size_t size, bool copy = false);
	void fetch(void* value, size_t size, bool text = false);
	virtual std::string id() = 0;
};

#endif
