/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_PI_TAG_H
#define _PICONF_PI_TAG_H

#include "../piconfm.hpp"
#include "../../../vio/IO.hpp"
#include "conf_tag.hpp"
#include "file_tag.hpp"
#include "shell_tag.hpp"
#include "daq_tag.hpp"
#include "tcp_tag.hpp"
#include <deque>

namespace piconf {
	class pi_tag;
}

class piconf::pi_tag : public tag {
	typedef std::deque<tag*> tag_box_t;
	typedef std::deque<io_tag*> io_box_t;
	typedef std::deque<conf_tag> conf_box_t;
	typedef std::deque<file_tag> file_box_t;
	typedef std::deque<shell_tag> shell_box_t;
	typedef std::deque<daq_tag> daq_box_t;
	typedef std::deque<tcp_tag> tcp_box_t;
	tag_box_t tag_box;
	io_box_t io_box;
	conf_box_t conf_box;
	file_box_t file_box;
	shell_box_t shell_box;
	daq_box_t daq_box;
	tcp_box_t tcp_box;
	bool inherit;
public:
	pi_tag(pugi::xml_node node);
	void setup();
	~pi_tag();
	virtual void schedule(const timespec* interval = 0, const timespec* realtime = 0, const timespec* accuracy = 0);
	bool process();
	void status(lines_t& lines);
};

#endif
