/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_TAG_H
#define _PICONF_TAG_H

#include "../piconfm.hpp"
#include "../../../pugixml/pugixml.hpp"
#include "../../../vio/IO.hpp"
#include <deque>
#include <vector>
#include <string>
#include <sstream>
#include <time.h>

namespace piconf {
	class tag;
	class io_tag;
	class data_tag;
}

class piconf::tag {
protected:
	pugi::xml_node node;
	tag(pugi::xml_node node);
	void save();
	std::string xml;
	uint32_t size;
	char* query;
	std::string what;
public:
	virtual void subscribe(std::deque<io_tag*>& io_box, bool inherit);
	virtual void handle(int code, std::string what);
	virtual void setup();
	virtual void schedule(const timespec* interval = 0, const timespec* realtime = 0, const timespec* accuracy = 0);
	virtual bool process();
	virtual void status(lines_t& lines);
	virtual ~tag();
};

#endif
