/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_CONF_TAG_H
#define _PICONF_CONF_TAG_H

#include "../piconfs.hpp"
#include "data_tag.hpp"

namespace piconf {
	class conf_tag;
}

class piconf::conf_tag : public data_tag {
	static char* data;
	static axi_map_box_t zdx_box;
	static pugi::xml_node tpl;
	static size_t highest_bit(pugi::xml_node node);
	static void write(void* data, pugi::xml_node tpl, pugi::xml_node tag);
	static void read(const void* data, pugi::xml_node tpl, pugi::xml_node tag, bool readback = false);
public:
	static void construct(std::ofstream& log, pugi::xml_node tpl);
	conf_tag(std::ofstream& log, pugi::xml_node tpl, pugi::xml_node tag, VIO::IO* io);
	void write(void* data);
	void read(const void* data);
	static void destruct();
};

#endif
