/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_IO_TAG_H
#define _PICONF_IO_TAG_H

#include "tag.hpp"
#include "data_tag.hpp"
#include "../../../vio/IO.hpp"
#include "../../../ape/ape.hpp"
#include <fstream>
#include <list>
#include <deque>

namespace piconf {
	class io_tag;
}

class piconf::io_tag : public tag {
protected:
	static std::ofstream log;
	timespec activate, timeout;
	typedef uint8_t state_t;
	state_t state;
	static const state_t
	READING_SIZE = 0x01,
	KNOWING_SIZE = 0x02,
	READING_XML  = 0x04,
	KNOWING_XML  = 0x08,
	PROCESSING   = 0x10,
	CLOSE        = 0x20,
	HOOKING_UP   = 0x40;
	typedef std::deque<VIO::IO*> queued_t;
	queued_t queued;
	data_tag* tag;
	typedef std::deque<data_tag::hooked_t*> hooked_t;
	hooked_t hooked;
	pugi::xml_node tpl;
	ape::tree tag_tree, tpl_tree;
	uint32_t size;
	char* xml;
public:
	io_tag(const char* tpl_file);
	bool process();
	static void sigterm(int signum);
	~io_tag();
};

#endif
