/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_SHELL_TAG_H
#define _PICONF_SHELL_TAG_H

#include "data_tag.hpp"

namespace piconf {
	class shell_tag;
}

class piconf::shell_tag : public data_tag {
	pugi::xml_node tpl;
	typedef uint8_t shell_state_t;
	shell_state_t shell_state;
	static const shell_state_t
	INVALID      = 0x01,
	NO_RETURN    = 0x02,
	DONE         = 0x04;
	pugi::xml_node input;
public:
	shell_tag(std::ofstream& log, pugi::xml_node tpl, pugi::xml_node tag, VIO::IO* io);
	bool process();
};

#endif
