/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_TCP_TAG_H
#define _PICONF_TCP_TAG_H

#include "io_tag.hpp"
#include "../../../vio/TCP.hpp"
#include "../../piconf/piconf.hpp"
#include <time.h>

namespace piconf {
	class tcp_tag;
}

class piconf::tcp_tag : public io_tag {
	VIO::TCP tcp;
	state_t tcp_state;
	static const state_t
	CONNECTED    = 0x01;
	std::string host;
public:
	tcp_tag(const char* xml_file);
	bool process();
	void handle(VIO::IO::Error& error, VIO::IO* io = 0);
	~tcp_tag();
};

#endif
