/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _VIO_FD_H
#define _VIO_FD_H

#include "IO.hpp"

#include <stdio.h>

namespace VIO {
	class FD;
}

class VIO::FD : public IO {
protected:
public:
	typedef uint8_t error_t;
	static const error_t
	FILENO = 11,
	FCNTL  = 12;
	class Error : public IO::Error {
	public:
		Error(const char* context, const char* message = 0, const void* instance = 0, int code = 0);
	};
	FD(int fd = -1);
	FD(FILE* stream);
	void assign(int fd);
	void assign(FILE* stream);
};

#endif
